
SimpleObjectivesMinimapButton = CreateFrame("Button",nil,UIParent)
SimpleObjectivesMinimapButton:SetMovable(true)
SimpleObjectivesMinimapButton:SetSize(32,32)
SimpleObjectivesMinimapButton:RegisterForClicks("LeftButtonUp")
SimpleObjectivesMinimapButton:RegisterForDrag("RightButton")

SimpleObjectivesHandler = CreateFrame("Frame", nil, UIParent)



SimpleObjectivesMinimapButton:SetScript("OnEvent",function(self, event, ...) self[event](self, ...) end)

SimpleObjectivesMinimapButton:RegisterEvent("ADDON_LOADED")

SimpleObjectivesMinimapButton:RegisterEvent("SCENARIO_CRITERIA_UPDATE")
SimpleObjectivesMinimapButton:RegisterEvent("PLAYER_REGEN_DISABLED")
SimpleObjectivesMinimapButton:RegisterEvent("PLAYER_REGEN_ENABLED")


SimpleObjectivesMinimapButton_Icon = SimpleObjectivesMinimapButton:CreateTexture()
SimpleObjectivesMinimapButton_Icon:SetTexture("Interface\\WorldMap\\UI-WorldMap-QuestIcon")
SimpleObjectivesMinimapButton_Icon:SetAllPoints();


SLASH_SOH1, SLASH_SOH2 = "/simpleobjectivehider", "/soh"

DEFAULT_TEX_COORDS = { 0, 0, 0, 0.5, 0.5, 0, 0.5, 0.5 }
CLICK_TEX_COORDS = { 0.5, 0, 0.5, 0.5, 1.0, 0, 1.0, 0.5 }

MouseOverride = false
ObjectiveVisibility = true
ObjectiveWQ = ""

sohaddonLoaded = false
nCrit = 0

local playerConditions = { InCombat = false, InGroup = false }


function SimpleObjectivesMinimapButton_OnDragStart()
	SimpleObjectivesMinimapButton:LockHighlight()
	SimpleObjectivesMinimapButton:StartMoving()
end
function SimpleObjectivesMinimapButton_OnDragStop()
	SimpleObjectivesMinimapButton:UnlockHighlight()
	SimpleObjectivesMinimapButton:StopMovingOrSizing()
	if (sohaddonLoaded == true) then
		MapPosPTemp = {SimpleObjectivesMinimapButton:GetPoint()}
		MapPosP = {MapPosPTemp[1],MapPosPTemp[3],MapPosPTemp[4],MapPosPTemp[5]}
		
		SOHDatsSL = {  MapPosP = MapPosP, ObjectiveVisible = ObjectiveVisibility }

		
	end
end

function SimpleObjectivesMinimapButton:PLAYER_REGEN_DISABLED()
	playerConditions["InCombat"] = true
end
function SimpleObjectivesMinimapButton:PLAYER_REGEN_ENABLED()
	playerConditions["InCombat"] = false
end
function SohConditionalUpdate()
	local moddingScale = false
	local moddingAlpha = false
	local isHidden = false

	local inGroupOrRaid = UnitInRaid("player")
	if inGroupOrRaid == nil then inGroupOrRaid = UnitInParty("player") end
	playerConditions["InGroup"] = inGroupOrRaid

	if (SohGetValue("HideGroup")) then
		if (playerConditions["InGroup"]) then
			ObjectiveTrackerFrame:SetAlpha(0)
			ObjectiveTrackerFrame:EnableMouse(false)
			isHidden = true
			moddingAlpha = true
		end
	end
	if (SohGetValue("HideSolo")) then
		if (not playerConditions["InGroup"]) then
			ObjectiveTrackerFrame:SetAlpha(0)
			ObjectiveTrackerFrame:EnableMouse(false)
			isHidden = true
			moddingAlpha = true
		end
	end
	if (SohGetValue("HideCombat")) then
		if(playerConditions["InCombat"]) then
			ObjectiveTrackerFrame:SetAlpha(0)
			ObjectiveTrackerFrame:EnableMouse(false)
			isHidden = true
			moddingAlpha = true
		end
	end
	if(moddingScale == false) then
		ObjectiveTrackerFrame:SetScale(SohGetValue("Scale"))
	end
	if(moddingAlpha == false) then
		ObjectiveTrackerFrame:SetAlpha(SohGetValue("Alpha"))
		if (SohGetValue("Alpha") > 0 and ObjectiveTrackerFrame:IsShown()) then
			ObjectiveTrackerFrame:EnableMouse(true)

		else
			ObjectiveTrackerFrame:EnableMouse(false)
			
		end
	end

	if (isHidden) then
		ObjectiveTrackerFrame:SetScale(0.001)
	end



end
local function disableFunc() end -- blank func for replacing functions :)

function SimpleObjectivesMinimapButton:ADDON_LOADED(arg1, ...)

	if (arg1 == "SimpleObjectives") then

		if SOHDatsSL == nil or SOHDatsSL.MapPosP == nil or SOHDatsSL.ObjectiveVisible == nil then
			MapPosP = {"TOPRIGHT", "TOPRIGHT", 0,0}
			SOHDatsSL = { MapPosP = MapPosP , ObjectiveVisible = true }
		end
		MapPosP = SOHDatsSL.MapPosP

		if (SOHDatsSL.ObjectivePos == nil) then
			local of1, _,of3,of4,of5 = ObjectiveTrackerFrame:GetPoint()
			SOHDatsSL.ObjectivePos = {of1, UIParent, of3, of4,of5}

		end

		ObjectivePos = SOHDatsSL.ObjectivePos
		ObjectiveVisibility = SOHDatsSL.ObjectiveVisible
		ToggleObjectives(true)
		SetDefaultTexture()
		local blockMaxHeight = (WorldFrame:GetHeight() - (Minimap:GetHeight())) - 10;

		SimpleObjectivesMinimapButton:SetPoint(MapPosP[1],UIParent,MapPosP[3],MapPosP[4],MapPosP[5])
		ObjectiveTrackerFrame:ClearAllPoints()
		ObjectiveTrackerFrame:SetPoint(ObjectivePos[1], UIParent, ObjectivePos[3], ObjectivePos[4], ObjectivePos[5])

		--Disable clear all points and setpoint by making it a blank func
		ObjectiveTrackerFrame.ClearAllPoints = disableFunc;
		ObjectiveTrackerFrame.SetPoint = disableFunc;
		
		ObjectiveTrackerFrame:SetHeight(blockMaxHeight)

		sohaddonLoaded = true
		ToggleMapIcon(SohGetValue("HideMapIcon"))
		SlashCmdList["SOH"] = SOHSlashHandler

		
		SimpleObjectivesHandler:SetScript("OnUpdate", function() HandleObjectivesFrame(); SohConditionalUpdate() end)
		InitSimpler()
	end

end
function SimpleObjectivesMinimapButton:SCENARIO_CRITERIA_UPDATE()
	local sType = select(10, C_Scenario.GetInfo())
	if sType == LE_SCENARIO_TYPE_CHALLENGE_MODE then
		local nCrita = select(3, C_Scenario.GetStepInfo())
		for cInd = 1, nCrita do
			local _, _, _, quantity, totalQuantity, _, _, _, _, _, _, _, weighted = C_Scenario.GetCriteriaInfo(cInd)
			if (weighted) then
				nCrit = quantity .. "%"
			end
		end
	end
end
function SOHSlashHandler(msg, ...)

	if (msg =="toggle") then
		if (not SimplerObjectives:IsShown()) then
			PlaySound(SOUNDKIT.U_CHAT_SCROLL_BUTTON)
			ToggleObjectives(false)
		else
			RaidNotice_AddMessage(RaidWarningFrame, "Toggling via macro and icon disabled whilst menu is open!", ChatTypeInfo["RAID_WARNING"])
		end
	else
		_G['SimplerObjectives']:Show();

	end

end

function ToggleMapIcon(init)		
		if (init == true) then
			SimpleObjectivesMinimapButton:Hide();
		else
			SimpleObjectivesMinimapButton:Show();
		end
end


function ToggleObjectives(startup)
	local objectFrame = ObjectiveTrackerFrame:IsShown()
	if startup == true then
		objectFrame = not ObjectiveVisibility
	end
	local chatMessage = ""
	
	if objectFrame then 
		chatMessage = "Objective Window: |cfff000f0Hidden"
		ObjectiveTrackerFrame:Hide() 
	else 
		chatMessage = "Objective Window: |cff00ff00Visible"
		ObjectiveTrackerFrame:Show() 
	end
	ObjectiveVisibility = ObjectiveTrackerFrame:IsShown()
	SOHDatsSL.ObjectiveVisible = ObjectiveVisibility
	return chatMessage
end
function SimpleObjectivesMinimapButton_OnClick()
	if (not SimplerObjectives:IsShown()) then
		PlaySound(SOUNDKIT.U_CHAT_SCROLL_BUTTON)
		RaidNotice_AddMessage(RaidWarningFrame, ToggleObjectives(false), ChatTypeInfo["RAID_WARNING"])
	else
		RaidNotice_AddMessage(RaidWarningFrame, "Toggling via macro and icon disabled whilst menu is open!", ChatTypeInfo["RAID_WARNING"])
	end
end
function SimpleObjectivesMinimapButton_OnMouseDown()
	MouseOverride = true;
	SetClickTexture()
end
function SimpleObjectivesMinimapButton_OnMouseUp()
	MouseOverride = false;
	SetDefaultTexture()
end
function SimpleObjectivesMinimapButton_OnLeave()
	MouseOverride = false;
	SetDefaultTexture()
	GameTooltip:Hide()
end

function SimpleObjectivesMinimapButton_OnEnter()
	SetClickTexture()
	GameTooltip:SetOwner(SimpleObjectivesMinimapButton_Icon, "ANCHOR_BOTTOMLEFT",0, 30)
	GameTooltip:SetText("|cffffffffSimple Objectives Hider")
	GameTooltip:AddLine("|cff666666Left Click - |cff00ff00Toggle Objectives")
	GameTooltip:AddLine("|cff666666Right Click - |cff00ff00Move This")

	local inst, instType = IsInInstance()
	if (not ObjectiveTrackerFrame:IsShown()) then
		if (inst and (instType == "party" or instType == nil)) then
			GameTooltip:AddLine("\n\r|cffffffffDungeon Objectives : ")
			for k,v in pairs(ScenarioObjectiveBlock.lines) do
				
				if (strfind("Enemy Forces", v.Text:GetText())) then
					GameTooltip:AddLine(nCrit)
				else
					GameTooltip:AddLine(v.Text:GetText())
				end
				
			end
		end
		
		GameTooltip:AddLine(ObjectiveWQ)
	end


	GameTooltip:Show()
end

function SetDefaultTexture()
	SimpleObjectivesMinimapButton_Icon:SetTexCoord(DEFAULT_TEX_COORDS[1],DEFAULT_TEX_COORDS[2],DEFAULT_TEX_COORDS[3],DEFAULT_TEX_COORDS[4],DEFAULT_TEX_COORDS[5],DEFAULT_TEX_COORDS[6],DEFAULT_TEX_COORDS[7],DEFAULT_TEX_COORDS[8])
end

function SetClickTexture()
	SimpleObjectivesMinimapButton_Icon:SetTexCoord(CLICK_TEX_COORDS[1],CLICK_TEX_COORDS[2],CLICK_TEX_COORDS[3],CLICK_TEX_COORDS[4],CLICK_TEX_COORDS[5],CLICK_TEX_COORDS[6],CLICK_TEX_COORDS[7],CLICK_TEX_COORDS[8])
end


function ObjectiveTrackerFrame_OnDragStart()
	if (ObjectiveTrackerFrame:IsMovable() and ObjectiveTrackerFrame:GetAlpha() > 0) then
		ObjectiveTrackerFrame:StartMoving()
	end
end
function ObjectiveTrackerFrame_OnDragStop()
	ObjectiveTrackerFrame:StopMovingOrSizing()
	local of1, _,of3,of4,of5 = ObjectiveTrackerFrame:GetPoint()
	SOHDatsSL.ObjectivePos = {of1, UIParent, of3, of4,of5}
end
function HandleObjectivesFrame()
	if (SimplerObjectives:IsShown() and ObjectiveTrackerFrame:GetAlpha() > 0) then
		ObjectiveTrackerFrame:EnableMouse(true)
		ObjectiveTrackerFrame:RegisterForDrag("LeftButton")
		ObjectiveTrackerFrame:SetMovable(true)
	else
		ObjectiveTrackerFrame:SetMovable(false)
	end
end



ObjectiveTrackerFrame:SetScript("OnDragStart",ObjectiveTrackerFrame_OnDragStart)
ObjectiveTrackerFrame:SetScript("OnDragStop",ObjectiveTrackerFrame_OnDragStop)

local FIX = CreateFrame("Frame");


SimpleObjectivesMinimapButton:SetScript("OnMouseDown",SimpleObjectivesMinimapButton_OnMouseDown)
SimpleObjectivesMinimapButton:SetScript("OnMouseUp",SimpleObjectivesMinimapButton_OnMouseUp)
SimpleObjectivesMinimapButton:SetScript("OnLeave",SimpleObjectivesMinimapButton_OnLeave)
SimpleObjectivesMinimapButton:SetScript("OnEnter",SimpleObjectivesMinimapButton_OnEnter)
SimpleObjectivesMinimapButton:SetScript("OnClick",SimpleObjectivesMinimapButton_OnClick)
SimpleObjectivesMinimapButton:SetScript("OnDragStart",SimpleObjectivesMinimapButton_OnDragStart)
SimpleObjectivesMinimapButton:SetScript("OnDragStop",SimpleObjectivesMinimapButton_OnDragStop)
