local SimplerObjectives = CreateFrame("Frame","SimplerObjectives",UIParent, BackdropTemplateMixin and "BackdropTemplate");
SimplerObjectives:EnableMouse(true)
SimplerObjectives:RegisterForDrag("LeftButton")
SimplerObjectives:SetMovable(true)
local SimplerObjectives_CloseButton = CreateFrame("Button", nil, SimplerObjectives, "UIPanelButtonTemplate")
SimplerObjectives_CloseButton:SetText("x")
SimplerObjectives_CloseButton:SetSize(16,16)
SimplerObjectives_CloseButton:SetPoint("TOPRIGHT", SimplerObjectives, "TOPRIGHT", -10, -16)
SimplerObjectives_CloseButton:SetScript("OnClick", function() SimplerObjectives:Hide() end)
SimplerObjectives:SetSize(400,280);

SimplerObjectives:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeSize = 8, insets = { left = 1, right = 1, top = 1, bottom = 1 }, edgeFile = "Interface/Tooltips/UI-Tooltip-Border" })
SimplerObjectives:SetBackdropColor(0.5,0.5,0.5,1)
SimplerObjectives:SetBackdropBorderColor(1,1,1,1)

SimplerObjectives:SetScript("OnKeyDown", function(self, key) if (key == "ESCAPE") then self:Hide() end end)
SimplerObjectives:SetPropagateKeyboardInput(true)
SimplerObjectives:SetPoint("CENTER",0,0)



SimplerObjectives_Header = SimplerObjectives:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
SimplerObjectives_Header:SetPoint("TOP", SimplerObjectives, "TOP",0, -20)

SimplerObjectives_Header:SetText("Simpler Objectives Hider v|cffaa00ff2.4a")

function InitSimpler()

	local SimplerObjectivesMenu = CreateFrame("Frame", nil, SimplerObjectives, BackdropTemplateMixin and "BackdropTemplate")
	SimplerObjectivesMenu:SetSize(380, 230)
	SimplerObjectivesMenu:SetPoint("TOP", SimplerObjectives_Header, "BOTTOM", 0 , -5)
	
	SimplerObjectivesMenu:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeSize = 8, insets = { left = 1, right = 1, top = 1, bottom = 1 }, edgeFile = "Interface/Tooltips/UI-Tooltip-Border" })
	SimplerObjectivesMenu:SetBackdropColor(0.8,0.8,0.8,1)
	SimplerObjectivesMenu:SetBackdropBorderColor(1,1,1,1)
	
	local SimplerObjectivesMenuCombat = CreateFrame("CheckButton", "SimplerObjectivesMenu_CombatCheckBox", SimplerObjectivesMenu, "ChatConfigCheckButtonTemplate")
	SimplerObjectivesMenuCombat:SetPoint("TOPLEFT", SimplerObjectivesMenu, "TOPLEFT",10, -10)
	SimplerObjectivesMenu_CombatCheckBoxText:SetText("Hide in Combat")
	SimplerObjectivesMenu_CombatCheckBox:SetChecked(SohGetValue("HideCombat"))
	SimplerObjectivesMenu_CombatCheckBox:SetScript("OnClick", function(self) SohSetValue("HideCombat", self:GetChecked()) end)
	
	-- hiding dungeons is redundant
	--[[local SimplerObjectivesMenuOutside = CreateFrame("CheckButton", "SimplerObjectivesMenu_OutsideCheckBox", SimplerObjectivesMenu, "ChatConfigCheckButtonTemplate")
	SimplerObjectivesMenuOutside:SetPoint("TOP", SimplerObjectivesMenuCombat, "BOTTOM",0, -10)
	SimplerObjectivesMenu_OutsideCheckBoxText:SetText("Hide in Dungeons/Raids")
	SimplerObjectivesMenu_OutsideCheckBox:SetChecked(SohGetValue("HideDungeon"))
	SimplerObjectivesMenu_OutsideCheckBox:SetScript("OnClick", function(self) SohSetValue("HideDungeon", self:GetChecked()) end)]]

	local SimplerObjectivesMenuSolo = CreateFrame("CheckButton", "SimplerObjectivesMenu_SoloCheckBox", SimplerObjectivesMenu, "ChatConfigCheckButtonTemplate")
	SimplerObjectivesMenuSolo:SetPoint("TOP", SimplerObjectivesMenuCombat, "BOTTOM",0, -10)
	SimplerObjectivesMenu_SoloCheckBoxText:SetText("Hide while Solo")
	SimplerObjectivesMenu_SoloCheckBox:SetChecked(SohGetValue("HideSolo"))
	SimplerObjectivesMenu_SoloCheckBox:SetScript("OnClick", function(self) SohSetValue("HideSolo", self:GetChecked()) end)

	local SimplerObjectivesMenuGroup = CreateFrame("CheckButton", "SimplerObjectivesMenu_GroupCheckBox", SimplerObjectivesMenu, "ChatConfigCheckButtonTemplate")
	SimplerObjectivesMenuGroup:SetPoint("TOP", SimplerObjectivesMenuSolo, "BOTTOM",0, -10)
	SimplerObjectivesMenu_GroupCheckBoxText:SetText("Hide in Groups")
	SimplerObjectivesMenu_GroupCheckBox:SetChecked(SohGetValue("HideGroup"))
	SimplerObjectivesMenu_GroupCheckBox:SetScript("OnClick", function(self) SohSetValue("HideGroup", self:GetChecked()) end)
	
	local SimplerObjectivesMenuSmart = CreateFrame("CheckButton", "SimplerObjectivesMenu_SmartCheckBox", SimplerObjectivesMenu, "ChatConfigCheckButtonTemplate")
	SimplerObjectivesMenuSmart:SetPoint("TOP", SimplerObjectivesMenuGroup, "BOTTOM",0, -10)
	SimplerObjectivesMenu_SmartCheckBoxText:SetText("Hide AddOn Icon")
	SimplerObjectivesMenu_SmartCheckBox:SetChecked(SohGetValue("HideMapIcon"))
	SimplerObjectivesMenu_SmartCheckBox:SetScript("OnClick", function(self) SohSetValue("HideMapIcon", self:GetChecked()) ToggleMapIcon(self:GetChecked()) end)


	
	local SimplerObjectivesMenu_ScaleHeader = SimplerObjectivesMenu:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	SimplerObjectivesMenu_ScaleHeader:SetText("Objectives Frame Scale")
	SimplerObjectivesMenu_ScaleHeader:SetPoint("TOPRIGHT", SimplerObjectivesMenu, "TOPRIGHT", -10 , -10)
	
	local SimplerObjectivesMenuScale = CreateFrame("Slider", "SimplerObjectivesMenu_ScaleSlider", SimplerObjectivesMenu, "OptionsSliderTemplate")
	SimplerObjectivesMenuScale:SetPoint("TOPRIGHT", SimplerObjectivesMenu_ScaleHeader, "BOTTOMRIGHT",0, -15)
	SimplerObjectivesMenuScale:SetMinMaxValues(0.1, 5)
	SimplerObjectivesMenuScale:SetValue(SohGetValue("Scale"))
	SimplerObjectivesMenu_ScaleSliderLow:SetText(0.1)
	SimplerObjectivesMenu_ScaleSliderText:SetText(format("%.2f", SohGetValue("Scale")))
	SimplerObjectivesMenu_ScaleSliderHigh:SetText(5)
	SimplerObjectivesMenuScale:SetScript("OnValueChanged", function(self) SohSetValue("Scale", self:GetValue()) SimplerObjectivesMenu_ScaleSliderText:SetText(format("%.2f", SohGetValue("Scale"))) end)

	local SimplerObjectivesMenu_AlphaHeader = SimplerObjectivesMenu:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	SimplerObjectivesMenu_AlphaHeader:SetText("Objectives Frame Alpha")
	SimplerObjectivesMenu_AlphaHeader:SetPoint("TOPRIGHT", SimplerObjectivesMenuScale, "TOPRIGHT", 0 , -30)
	
	local SimplerObjectivesMenuAlpha = CreateFrame("Slider", "SimplerObjectivesMenu_AlphaSlider", SimplerObjectivesMenu, "OptionsSliderTemplate")
	SimplerObjectivesMenuAlpha:SetPoint("TOPRIGHT", SimplerObjectivesMenu_AlphaHeader, "BOTTOMRIGHT",0, -15)
	SimplerObjectivesMenuAlpha:SetMinMaxValues(0, 1)
	SimplerObjectivesMenuAlpha:SetValue(SohGetValue("Alpha"))
	SimplerObjectivesMenu_AlphaSliderLow:SetText(0)
	SimplerObjectivesMenu_AlphaSliderText:SetText(format("%.2f", SohGetValue("Alpha")))
	SimplerObjectivesMenu_AlphaSliderHigh:SetText(1)
	SimplerObjectivesMenuAlpha:SetScript("OnValueChanged", function(self) SohSetValue("Alpha", self:GetValue()) SimplerObjectivesMenu_AlphaSliderText:SetText(format("%.2f", SohGetValue("Alpha"))) end)

	local SimplerObjectives_ToggleSH = CreateFrame("Button", nil, SimplerObjectivesMenu, "UIPanelButtonTemplate")
	SimplerObjectives_ToggleSH:SetText("Toggle Visibility [".. (ObjectiveTrackerFrame:IsShown() and "Visible" or "Hidden") .."]")
	SimplerObjectives_ToggleSH:SetSize(366,32)
	SimplerObjectives_ToggleSH:SetPoint("BOTTOMRIGHT", SimplerObjectivesMenu, "BOTTOMRIGHT", -6, 10)
	SimplerObjectives_ToggleSH:SetScript("OnClick", function(self) ToggleObjectives(false); self:SetText("Toggle Visibility [".. (ObjectiveTrackerFrame:IsShown() and "Visible" or "Hidden") .."]") end)

	local SimplerObjectivesMenu_Note = SimplerObjectivesMenu:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	SimplerObjectivesMenu_Note:SetPoint("BOTTOM", SimplerObjectivesMenu, "BOTTOM",0, 60)
	SimplerObjectivesMenu_Note:SetText("Objectives Frame is movable whilst menu is open.")
end

function SohGetValue(val)
	if (SOHDatsSL.Options == nil) then
		SOHDatsSL.Options = { Scale = 1, Alpha = 1, HideCombat = false, HideSolo = false, HideGroup = false, HideMapIcon = false}
	end
	return SOHDatsSL.Options[val] or nil
end

function SohSetValue(option, newVal)
	SOHDatsSL.Options[option] = newVal
end

function SimplerObjectives_OnDragStart()
	SimplerObjectives:StartMoving()
end
function SimplerObjectives_OnDragStop()
	SimplerObjectives:StopMovingOrSizing()
end

SimplerObjectives:SetScript("OnDragStart",SimplerObjectives_OnDragStart)
SimplerObjectives:SetScript("OnDragStop",SimplerObjectives_OnDragStop)

SimplerObjectives:Hide();
